<template>
  <div class="auth-v1">
    <b-row class="m-0 p-0">
      <!-- Login v1 -->
      <b-col lg="8" class="p-0">
        <div :style="{ 'background-image': 'url(' + bgImgOne + ')' }" class="login-bg"></div>
      </b-col>
      <b-col lg="4" class="d-flex align-items-center auth-bg">
        <div class="auth-wrapper auth-v1" :style="{ 'background-image': 'url(' + bgImg + ')' }">
          <div class="auth-inner p-0">
            <span class="brand-logo">
              <b-img :src="appLogoImage" alt="logo" class="brand-main-logo" />
            </span>
            <!-- Login v1 -->
            <b-card class="mb-0 login-card" id="loginCard">
              <h1 class="login-header">
                <span @click="resetPage()"><IconBackHome class="login-back-btn"></IconBackHome></span>
                <span>Forgot Password</span>
                <p>Don’t Worry!</p>
              </h1>
              <p class="login-desc" v-if="!isPassword">Please enter verification code to reset your password.</p>
              <p class="login-desc" v-if="isPassword">Please enter new password to reset your <br>password.</p>
              <!-- form -->
              <b-form class="auth-login-form mt-2">
                <!-- email -->
                <label class="form-label" for="email">Email ID</label>
                <b-form-group label-for="login-email">
                  <b-form-input id="login-email" class="text-transform-none" v-model="userEmail" name="login-email"
                    readonly placeholder="Enter Your Email" autofocus />
                </b-form-group>
              </b-form>
              <template v-if="!isPassword">
                <p class="verification-label">Enter Verification Code</p>
                <b-form-group label-for="otp" class="otp-box">
                  <div class="d-flex gap-2">
                    <b-form-input class="otp-input" ref="loginOtpOne" v-model="loginOtpOne" id="otp" name="otp1"
                      maxlength="1" @keydown="otpInputDown(1, $event)" @input="otpInput(1, $event)"
                      v-on:keypress="isNumber($event)" autofocus />
                    <b-form-input class="otp-input" ref="loginOtpTwo" v-model="loginOtpTwo" id="otp" name="otp2"
                      maxlength="1" @keydown="otpInputDown(2, $event)" @input="otpInput(2, $event)"
                      v-on:keypress="isNumber($event)" />
                    <b-form-input class="otp-input" ref="loginOtpThree" v-model="loginOtpThree" id="otp" name="otp3"
                      maxlength="1" @keydown="otpInputDown(3, $event)" @input="otpInput(3, $event)"
                      v-on:keypress="isNumber($event)" />
                    <b-form-input class="otp-input" ref="loginOtpFour" v-model="loginOtpFour" id="otp" name="otp4"
                      maxlength="1" @keydown="otpInputDown(4, $event)" @input="otpInput(4, $event)"
                      v-on:keypress="isNumber($event)" />
                  </div>
                </b-form-group>

                <p class="coundown-label" v-if="0 < countDown">
                  <small>
                    <IconOtpSend class="sms-icon" />Resend Verification
                    Code<span class="sms-time">(00:{{ time }})</span></small>
                </p>
                <p class="coundown-label-link" v-if="countDown < 1">
                  <b-link @click="resetOtp">
                    <small><IconOtpResend class="sms-icon" />Resend Verification
                      Code</small>
                  </b-link>
                </p>
              </template>
              <template v-if="isPassword">
                <Form   @submit="resetPassword"
                  :validation-schema="schema" v-slot="{meta}">
                    <!-- email -->
                    <b-form-group>
                      <div class="d-flex justify-content-between">
                        <!-- <label for="login-password">Password <span class="text-danger"> *</span></label> -->
                      </div>
                      <PasswordInput
                            ref="passwprd"
                            name="password" 
                            label="Password"
                            placeholder="Enter Password"
                            :value="password"
                            :maxlength="50"
                            :autofocus="true"></PasswordInput>
                    </b-form-group>

                    <b-form-group>
                      <div class="d-flex justify-content-between">
                        <!-- <label for="login-password">Confirm Password <span class="text-danger"> *</span></label> -->
                      </div>
                      
                      <PasswordInput
                            ref="passwprd"
                            name="confirm-password" 
                            label="Confirm Password"
                            placeholder="Enter Confirm Password"
                            :value="password"
                            :maxlength="50"></PasswordInput>
                        
                    </b-form-group>

                    <!-- submit buttons -->
                    <center>
                      <b-button type="submit"  class="login-btn" variant="primary" block >
                        <b-spinner small v-if="isSubmit" />
                        Reset Password
                      </b-button>
                      <!-- <b-button variant="secondary"  class="login-btn mute-btn" block @click="formValidate()"
                        v-if="!isBtnEnabled">
                        Reset Password
                      </b-button> -->
                    </center>
                   </Form>
              </template>
            </b-card>
            <p class="verification-label">or</p>
            <center>
              <b-button class="forgot-login-btn" block @click="resetPage()">
                Login
              </b-button>
              <div v-if="isSuccess" class="success-msg-block">
                <b-img :src="successIcon" size="15" />
                <p class="success-msg">{{ successMessage }}</p>
              </div>
              </center>
            <!-- /Login v1 -->
          </div>
        </div>
      </b-col>
      <!-- /Login v1 -->
    </b-row>
  </div>
</template>

<script>
import {
  BRow,
  BImg,
  BCol,
  BButton,
  BForm,
  BFormInput,
  BFormGroup,
  BCard,
  BLink,
  BCardTitle,
  BCardText,
  BInputGroup,
  BInputGroupAppend,
  BFormCheckbox,
  BAlert,
  BSpinner,
} from "bootstrap-vue";
import VuexyLogo from "@core/layouts/components/Logo.vue";
import Auth from "@/apis/Auth";
import ToastificationContent from "@core/components/toastification/ToastificationContent.vue";
import {
  togglePasswordVisibility,
  toggleNewPasswordVisibility,
} from "@core/mixins/ui/forms";
import { $themeConfig } from "@themeConfig";
import { useToast } from "vue-toastification";
const toast = useToast();
import * as yup from 'yup';
import { Form, useForm, ErrorMessage, Field } from 'vee-validate';
export default {
  components: {
    // BSV
    Form,
    BRow,
    BImg,
    BCol,
    BButton,
    BForm,
    BFormInput,
    BFormGroup,
    BCard,
    BCardTitle,
    BLink,
    VuexyLogo,
    BCardText,
    BInputGroup,
    BInputGroupAppend,
    BFormCheckbox,
    BAlert,
    BSpinner,
  },
  mixins: [togglePasswordVisibility, toggleNewPasswordVisibility],

  computed: {
    passwordToggleIcon() {
      return this.passwordFieldType === "password" ? "EyeOffIcon" : "EyeIcon";
    },
    newPasswordToggleIcon() {
      return this.newPasswordFieldType === "password" ? "EyeOffIcon" : "EyeIcon";
    },
  },
  data() {
    let userEmailId;
    if (this.$route.query.mail != "") {
      userEmailId = this.$route.query.mail;
    } else {
      userEmailId = "";
    }
    const { appLogoImage, bgImgOne, appBodyBG, successIcon} = $themeConfig.app;
    const schema = yup.object({
    password: yup.string().required("Please enter Password").min(6, "Password must be at least 6 characters"),
    "confirm-password": yup.string().required("Please enter Confirm Password").min(6, "Confirm Password must be at least 6 characters").oneOf([yup.ref('password')], "Confirm Password does not match with Password")
    
  });
  const { meta, setErrors  } = useForm({ validationSchema: schema });
    return {
      meta,
      setErrors,
      schema,
      errors: {},
      appLogoImage,
      bgImg: appBodyBG,
      bgImgOne,
      successIcon,
      userEmail: userEmailId,
      isSuccess: false,
      successMessage: "",
      userOtp: "",
      isSubmit: false,
      isPassword: false,
      password: "",
      cpassword: "",
      loginOtpOne: "",
      loginOtpTwo: "",
      loginOtpThree: "",
      loginOtpFour: "",
      countDown: 30,
      time: "30",
      isBtnEnabled: true,
    };
  },
  mounted() {
    this.login();
  },
  methods: {
    formValidate() {
      return true;
    },
    
    otpInputDown(input, e) {
      if (e.key === "Backspace" || e.key === "Delete") {
        if (input == 2) {
          if (e.target.value == "") {
            this.$refs.loginOtpOne.focus();
          }
        }
        if (input == 3) {
          if (e.target.value == "") {
            this.$refs.loginOtpTwo.focus();
          }
        }
        if (input == 4) {
          if (e.target.value == "") {
            this.$refs.loginOtpThree.focus();
          }
        }
      }
    },
    otpInput(input, e) {
      if (input == 1) {
        if (e != "") {
          setTimeout(() => {
            this.$refs.loginOtpTwo.focus();
          }, 100);
        }
      }
      if (input == 2) {
        if (e != "") {
          this.$refs.loginOtpThree.focus();
        }
      }
      if (input == 3) {
        if (e != "") {
          this.$refs.loginOtpFour.focus();
        }
      }
      if (input == 4) {
        if (e != "") {
          if (
            this.loginOtpOne != "" &&
            this.loginOtpTwo != "" &&
            this.loginOtpThree != "" &&
            this.loginOtpFour != ""
          ) {
            this.otpVerify();
          }
        }
      }
    },
    countDownTimer() {
      if (this.countDown > 0) {
        setTimeout(() => {
          this.countDown -= 1;
          if (this.countDown.toString().length > 1) {
            this.time = this.countDown;
          } else {
            this.time = "0" + this.countDown;
          }
          this.countDownTimer();
        }, 1000);
      }
    },
    resetPage() {
      this.$router.push({
        name: "login",
      });
    },
    isNumber(e) {
      let char = String.fromCharCode(e.keyCode); // Get the character
      if (/^[0-9]+$/.test(char)) return true;
      // Match with regex
      else e.preventDefault(); // If not match, don't add to input text
    },
    login() {
      const appLoading = document.getElementById("loading-bg");
      if (appLoading) {
        appLoading.style.display = "block";
      }
      setTimeout(() => {
        Auth.forgotPassword({
          email: this.userEmail,
        })
          .then((response) => {
            const data = response.data;
            if (data.status == true) {
              this.isSuccess = true;
              this.successMessage = data.message;
              this.countDown = 30;
              this.time = "30";
              this.countDownTimer();

              appLoading.style.display = "none";
            } else {
              toast({
                component: ToastificationContent,
                props: {
                  variant: "danger",
                  icon: "AlertCircleIcon",
                  title: data.title,
                  text: data.message,
                },
              });
             
              appLoading.style.display = "none";
              this.$router.push({
                name: "login",
              });
            }
          })
          .catch((error) => {
            toast({
              component: ToastificationContent,
              props: {
                title: "Error",
                icon: "AlertCircleIcon",
                text: "Something went wrong. Please try later.",
                variant: "danger",
              },
            });
            appLoading.style.display = "none";
            this.$router.push({
              name: "login",
            });
          });
      }, 500);
    },
    otpVerify() {
      const appLoading = document.getElementById("loading-bg");
      if (appLoading) {
        appLoading.style.display = "block";
      }
      this.userOtp =
        this.loginOtpOne + this.loginOtpTwo + this.loginOtpThree + this.loginOtpFour;
      Auth.forgotOtpVerify({
        email: this.userEmail,
        otp: this.userOtp,
      })
        .then((response) => {
          const data = response.data;
          if (data.status == true) {
            appLoading.style.display = "none";
            this.isPassword = true;
            this.isSuccess = false;
            console.log(this.$refs.loginOtpFive);
          } else {
            appLoading.style.display = "none";
            toast({
              component: ToastificationContent,
              props: {
                variant: "danger",
                icon: "AlertCircleIcon",
                title: data.title,
                text: data.message,
              },
            });
           
          }
        })
        .catch((error) => {
          appLoading.style.display = "none";
          toast({
            component: ToastificationContent,
            props: {
              title: "Error",
              icon: "AlertCircleIcon",
              text: "Something went wrong. Please try later.",
              variant: "danger",
            },
          });
        });
    },
    
    resetPassword(values, {setErros}) {
      // this.$refs.setPasswordForm.validate().then((success) => {
        if (true) {
          const appLoading = document.getElementById("loading-bg");
          if (appLoading) {
            appLoading.style.display = "block";
          }
          this.isSubmit = true;
          this.userOtp =
            this.loginOtpOne + this.loginOtpTwo + this.loginOtpThree + this.loginOtpFour;
          Auth.setPassword({
            email: this.userEmail,
            otp: this.userOtp,
            password: values.password,
            confirm_password: values['confirm-password'],
          })
            .then((response) => {
              const data = response.data;
              if (response.data.status == true) {
                this.isSubmit = false;
                appLoading.style.display = "none";
                this.$router
                  .push({
                    name: "login",
                  })
                  .then(() => {
                    toast({
                      component: ToastificationContent,
                      props: {
                        variant: "success",
                        icon: "CheckCircleIcon",
                        title: data.title,
                        text: data.message,
                      },
                    });
                  });
              } else {
                appLoading.style.display = "none";
                if (data.errors) {
                  this.errors = data.errors;
                } else {
                  toast({
                    component: ToastificationContent,
                    props: {
                      title: data.title,
                      icon: "AlertCircleIcon",
                      text: data.message,
                      variant: "danger",
                    },
                  });
                }
                this.isSubmit = false;
              }
            })
            .catch((error) => {
              appLoading.style.display = "none";
              toast({
                component: ToastificationContent,
                props: {
                  title: "Error",
                  icon: "AlertCircleIcon",
                  text: "Something went wrong. Please try later.",
                  variant: "danger",
                },
              });
              this.isSubmit = false;
            });
        }
      // });
    },
    resetOtp() {
      const appLoading = document.getElementById("loading-bg");
      if (appLoading) {
        appLoading.style.display = "block";
      }
      this.isSubmit = true;
      if (this.userEmail != "") {
        Auth.forgotPassword({
          email: this.userEmail,
          resend: true,
        })
          .then((response) => {
            const data = response.data;
            if (data.status == true) {
              appLoading.style.display = "none";
              this.loginOtpOne = "";
              this.loginOtpTwo = "";
              this.loginOtpThree = "";
              this.loginOtpFour = "";
              this.isSubmit = false;
              this.isSuccess = true;
              this.successMessage = data.message;
              this.countDown = 30;
              this.time = "30";
              this.$refs.loginOtpOne.focus();
              this.countDownTimer();
            } else {
              appLoading.style.display = "none";
              toast({
                component: ToastificationContent,
                props: {
                  variant: "danger",
                  icon: "AlertCircleIcon",
                  title: data.title,
                  text: data.message,
                },
              });
              this.isSubmit = false;
            }
          })
          .catch((error) => {
            appLoading.style.display = "none";
            toast({
              component: ToastificationContent,
              props: {
                title: "Error",
                icon: "AlertCircleIcon",
                text: "Something went wrong. Please try later.",
                variant: "danger",
              },
            });
            this.isSubmit = false;
          });
      }
    },
    isNumber(e) {
      let char = String.fromCharCode(e.keyCode); // Get the character
      if (/^[0-9]+$/.test(char)) return true;
      // Match with regex
      else e.preventDefault(); // If not match, don't add to input text
    },
  },
};
</script>

<style lang="scss">
@import "~@resources/scss/vue/pages/page-auth.scss";
.auth-v1 {
    .login-bg {
      height: 100%;
      background-size: cover;
    }
    .auth-inner {
    }
  }
  .brand-logo {
    display: flex;
    justify-content: center;
  }
</style>
